if not Restoration then
	log("[Customize Restoration] This mod requires restoration mod in order to work!")
	return
end
Restoration.modifiers = {
	["lib/managers/hud/hudassaultcorner"] = "lua/hudassaultcorner.lua",
	["lib/managers/hud/hudobjectives"] = "lua/hudobjectives.lua",
}	
function Restoration:clone( class )
	class.Old = clone(class)
end
function Restoration:colorize()
	Restoration.assault_color = Restoration.colors[Restoration.options.AssaultTape_color]
	Restoration.escape_color  = Restoration.colors[Restoration.options.EscapeTape_color]
	Restoration.casing_color  = Restoration.colors[Restoration.options.CasingTape_color]	
	Restoration.assault_textcolor = Restoration.colors[Restoration.options.AssaultTape_textcolor]
	Restoration.escape_textcolor  = Restoration.colors[Restoration.options.EscapeTape_textcolor]
	Restoration.casing_textcolor  = Restoration.colors[Restoration.options.CasingTape_textcolor]	
	Restoration.objective_color   = Restoration.colors[Restoration.options.ObjectiveBox_color]	
	Restoration.objective_textcolor  = Restoration.colors[Restoration.options.ObjectiveBox_textcolor]	
	tweak_data.menu.default_font_row_item_color = Restoration.colors[Restoration.options.Menu_textcolor]	
	tweak_data.menu.default_hightlight_row_item_color = Restoration.colors[Restoration.options.Menu_highlight_textcolor]	
	if managers.hud then
		managers.hud._hud_assault_corner:colorize()	
		managers.hud._hud_objectives:colorize()	
	end
end
if not Restoration.setup_modifer then
	Restoration.colors = { 
		Color(0.31, 0.72 ,1 ),	  	 
		Color(1,0.6 ,0 ),
		Color(0, 1, 0.1), 	
		Color(1, 0.25, 0.7), 		 
		Color(0, 0, 0),		 		 
		Color(0.15, 0.15, 0.15),
		Color(0.1, 0.1, 0.35), 
		Color(1, 0.1, 0), 
		Color(1, 0.8, 0.2), 
		Color(1, 1, 1), 
		Color(0, 1, 0.9),
		Color(0.5, 0, 1),
		Color(0, 0.9, 0.5),
		Color(0.6,0.8,0.85),
		Color(1, 0, 0.2),
		Color(0.5,0.3,0.17),
		Color(0.7, 0.9, 0), 
	}
	Restoration.color_names = {
		"color_blue",
		"color_orange",
		"color_green",
		"color_pink",
		"color_black",
		"color_grey",
		"color_darkblue",
		"color_red",
		"color_yellow",
		"color_white",
		"color_cyan",
		"color_purple",
		"color_springgreen",
		"color_lightblue",
		"color_crimson",
		"color_brown",
		"color_lime",
	}	
	Restoration:Load()
	Restoration.options.defaults = {
		AssaultTape_color = 9,
		EscapeTape_color = 8,
		CasingTape_color = 10,		
		ObjectiveBox_color = 1,		
		AssaultTape_textcolor = 5,
		EscapeTape_textcolor = 5,
		CasingTape_textcolor = 5,
		ObjectiveBox_textcolor = 5,
		Menu_textcolor = 10,
		Menu_highlight_textcolor = 5,
	}
	for option, value in pairs(Restoration.options.defaults) do
		if Restoration.options[option] == nil then
			Restoration.options[option] = value	
			Restoration:Save()
		end
	end	
	Restoration:Load()
	Restoration.setup_modifer = true
	Restoration:colorize()
	log("[Customize Restoration] Done loading all settings.")
end

if RequiredScript then
	local requiredScript = RequiredScript:lower()
	if Restoration.modifiers[requiredScript] then
 		dofile( ModPath .. Restoration.modifiers[requiredScript] )
	end	
end

if Hooks then
	Hooks:Add("LocalizationManagerPostInit", "restoration_loc", function(loc)
		LocalizationManager:add_localized_strings({
	    ["AssaultTape_color"] = "Assault tape color",
	    ["AssaultTape_color_desc"] = "",    
	    ["CasingTape_color"] = "Casing tape color",
	    ["CasingTape_color_desc"] = "",    
	    ["EscapeTape_color"] = "Escape tape color",
	    ["EscapeTape_color_desc"] = "",	    
	    ["ObjectiveBox_color"] = "Objective box color",
	    ["ObjectiveBox_color_desc"] = "",	    
	    ["AssaultTape_textcolor"] = "Assault tape text color",
	    ["AssaultTape_textcolor_desc"] = "",    
	    ["CasingTape_textcolor"] = "Casing tape text color",
	    ["CasingTape_textcolor_desc"] = "",    
	    ["EscapeTape_textcolor"] = "Escape tape text color",
	    ["EscapeTape_textcolor_desc"] = "",	    
	    ["ObjectiveBox_textcolor"] = "Objective box text color",
	    ["ObjectiveBox_textcolor_desc"] = "",	    
	    ["Menu_textcolor"] = "Menu text color",
	    ["Menu_textcolor_desc"] = "",	    
	    ["Menu_highlight_textcolor"] = "Menu highlight text color",
	    ["Menu_highlight_textcolor_desc"] = "",	    
	    ["restoration_reset_btn"] = "Reset extras",
	    ["restoration_reset_btn_desc"] = "",
		["color_blue"] = "Blue",
		["color_orange"] = "Orange",
		["color_green"] = "Green",
		["color_pink"] = "Pink",
		["color_black"] = "Black",
		["color_grey"] = "Grey",
		["color_darkblue"] = "Dark blue",
		["color_red"] = "Red",
		["color_yellow"] = "Yellow",
		["color_white"] = "White",
		["color_cyan"] = "Cyan",
		["color_purple"] = "Purple",
		["color_springgreen"] = "Spring green",
		["color_lightblue"] = "Light blue",
		["color_crimson"] = "Crimson",
		["color_brown"] = "Brown",
		["color_lime"] = "Lime",
	  })
	end)
    MenuCallbackHandler.restoration_set_value = function(self, item)
		Restoration.options[item._parameters.name] = item:value()
		Restoration:Save()			
		Restoration:colorize()
    end      
    MenuCallbackHandler.restoration_reset_btn = function(self, item)
	    for option, value in pairs(Restoration.options.defaults) do
			MenuHelper:ResetItemsToDefaultValue( item, {[option] = true}, value )
			Restoration:Save()
		end	
    end    
	Hooks:Add("MenuManagerPopulateCustomMenus", "Restoration_customize_modifier", function(menu_manager, nodes)			
		MenuHelper:AddMultipleChoice({
		    id = "AssaultTape_color",
		    title = "AssaultTape_color",
		    desc = "AssaultTape_color_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.AssaultTape_color,
		    menu_id = Restoration.main_menu,
		    priority = 999,
		})				
		MenuHelper:AddMultipleChoice({
		    id = "AssaultTape_textcolor",
		    title = "AssaultTape_textcolor",
		    desc = "AssaultTape_textcolor_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.AssaultTape_textcolor,
		    menu_id = Restoration.main_menu,
		    priority = 998,
		})		
		MenuHelper:AddMultipleChoice({
		    id = "CasingTape_color",
		    title = "CasingTape_color",
		    desc = "CasingTape_color_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.CasingTape_color,
		    menu_id = Restoration.main_menu,
		    priority = 997,
		})				
		MenuHelper:AddMultipleChoice({
		    id = "CasingTape_textcolor",
		    title = "CasingTape_textcolor",
		    desc = "CasingTape_textcolor_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.CasingTape_textcolor,
		    menu_id = Restoration.main_menu,
		    priority = 996,
		})		
		MenuHelper:AddMultipleChoice({
		    id = "EscapeTape_color",
		    title = "EscapeTape_color",
		    desc = "EscapeTape_color_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.EscapeTape_color,
		    menu_id = Restoration.main_menu,
		    priority = 995,
		})		
		MenuHelper:AddMultipleChoice({
		    id = "EscapeTape_textcolor",
		    title = "EscapeTape_textcolor",
		    desc = "EscapeTape_textcolor_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.EscapeTape_textcolor,
		    menu_id = Restoration.main_menu,
		    priority = 994,
		})
		MenuHelper:AddMultipleChoice({
		    id = "ObjectiveBox_color",
		    title = "ObjectiveBox_color",
		    desc = "ObjectiveBox_color_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.ObjectiveBox_color,
		    menu_id = Restoration.main_menu,
		    priority = 993,
		})		
		MenuHelper:AddMultipleChoice({
		    id = "ObjectiveBox_textcolor",
		    title = "ObjectiveBox_textcolor",
		    desc = "ObjectiveBox_textcolor_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.ObjectiveBox_textcolor,
		    menu_id = Restoration.main_menu,
		    priority = 992,
		})		
		MenuHelper:AddMultipleChoice({
		    id = "Menu_textcolor",
		    title = "Menu_textcolor",
		    desc = "Menu_textcolor_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.Menu_textcolor,
		    menu_id = Restoration.main_menu,
		    priority = 991,
		})		
		MenuHelper:AddMultipleChoice({
		    id = "Menu_highlight_textcolor",
		    title = "Menu_highlight_textcolor",
		    desc = "Menu_highlight_textcolor_desc",
		    callback = "restoration_set_value",
		    items = Restoration.color_names,
		    value = Restoration.options.Menu_highlight_textcolor,
		    menu_id = Restoration.main_menu,
		    priority = 990,
		})
		MenuHelper:AddDivider({
		    id = "moreoptions_div_1",
		    size = 24,
		    menu_id = Restoration.main_menu,
		})		
		MenuHelper:AddButton({
		    id = "restoration_reset_btn",
		    title = "restoration_reset_btn",
		    desc = "restoration_reset_btn_desc",
		    callback = "restoration_reset_btn",
		    menu_id = Restoration.main_menu,
		    priority = 989,
		})
		MenuHelper:AddDivider({
		    id = "moreoptions_div_2",
		    size = 24,
		    menu_id = Restoration.main_menu,
		})
	end)	
end