Restoration:clone(HUDAssaultCorner)
function HUDAssaultCorner:init( ... )
	self.Old.init(self, ...)
	self:colorize()
end
function HUDAssaultCorner:colorize()
	local assault_panel = self._hud_panel:child("assault_panel")		
	local point_of_no_return_panel = self._hud_panel:child("point_of_no_return_panel")		
	local casing_panel = self._hud_panel:child("casing_panel")		
	local assault_corner = self._hud_panel:child("assault_corner")		
	local yellow_tape = assault_panel:child("yellow_tape")
	local red_tape = point_of_no_return_panel:child("red_tape")
	local point_of_no_return_timer = point_of_no_return_panel:child("point_of_no_return_timer")
	local white_tape = casing_panel:child("white_tape")
	yellow_tape:set_color(Restoration.assault_color)
	red_tape:set_color(Restoration.escape_color)
	white_tape:set_color(Restoration.casing_color)
	yellow_tape:set_blend_mode("normal")
	red_tape:set_blend_mode("normal")
	white_tape:set_blend_mode("normal")	
	yellow_tape:set_alpha(0.8)
	red_tape:set_alpha(0.8)
	white_tape:set_alpha(0.8)
end
function HUDAssaultCorner:sync_set_assault_mode(mode)
	if self._assault_mode == mode then
		return
	end
	self._assault_mode = mode
	local color = self._assault_color
	if mode == "phalanx" then
		color = self._vip_assault_color
	end
	self._current_assault_color = color

	self:_set_text_list(self:_get_assault_strings())
	local assault_panel = self._hud_panel:child("assault_panel")
end
function HUDAssaultCorner:_animate_text(text_panel, bg_box, color)
	local text_list = (text_panel or self._hud_panel:child("assault_panel")):script().text_list
	local text_index = 0
	local texts = {}
	local padding = 10
	local y = 15
   
	local function create_new_text(text_panel, text_list, text_index, texts)
		if texts[text_index] and texts[text_index].text then
			text_panel:remove(texts[text_index].text)
			texts[text_index] = nil
		end
		local text_id = text_list[text_index]
		local text_string = ""
		if type(text_id) == "string" then
			local tab = {}
			tab = self._casing and self._custom_lines_casing or self._assault and self._custom_lines_assault or self._point_of_no_return and self._custom_lines_ponr
			tab = self._assault_mode == "phalanx" and self._custom_lines_phalanx or self._casing_mode == "civilian" and self._custom_lines_civilian or tab
			if #tab > 0 and text_id ~= "hud_assault_end_line" and text_id ~= "hud_assault_padlock" and self._custom_line_chance > math.random(100) then
				text_string = tab[math.random(#tab)]
			else
				text_string = managers.localization:to_upper_text(text_id)
			end
		elseif text_id == Idstring("risk") then
			for i = 1, managers.job:current_difficulty_stars() do
				text_string = text_string .. managers.localization:get_default_macro("BTN_SKULL")
			end
		end
	   
		local text = text_panel:text({
			text = text_string,
			layer = 1,
			align = "center",
			vertical = "center",
			color = self._assault and Restoration.assault_textcolor or self._casing and Restoration.casing_textcolor or self._point_of_no_return and Restoration.escape_textcolor or Color.black ,
			font_size = tweak_data.hud_corner.assault_size * 1.2,
			font = "fonts/font_large_mf",
			w = 10,
			h = 10
		})
		local _, _, w, h = text:text_rect()
		text:set_size(w, h)
		text:set_rotation(30)
		texts[text_index] = {
			x = text_panel:w() + w * 0.5 + padding * 2,
			text = text
		}
	end
	while true do
		local dt = coroutine.yield()
		local last_text = texts[text_index]
		if last_text and last_text.text then
			if last_text.x + last_text.text:w() * 0.5 + padding < text_panel:w() then
				text_index = text_index % #text_list + 1
				create_new_text(text_panel, text_list, text_index, texts)
			end
		else
			text_index = text_index % #text_list + 1
			create_new_text(text_panel, text_list, text_index, texts)
		end
		local speed = self.TAPE_SPEED
		for i, data in pairs(texts) do
			if data.text then
				data.x = data.x - dt * speed
				data.text:set_center_x( math.cos(30) * (data.x + 15) )
				data.text:set_center_y( math.sin(30) * (data.x - text_panel:w()*0.5 + 100) - y )
				if data.x + data.text:w() * math.cos(30) < 0 then
					text_panel:remove(data.text)
					data.text = nil
				end
			end
		end
	end
end

