Restoration:clone(HUDObjectives)
function HUDObjectives:init( ... )
	self.Old.init(self, ...)
	self:colorize()
end
function HUDObjectives:colorize()
	local objectives_panel = self._hud_panel:child("objectives_panel")
	local objective_text = objectives_panel:child("objective_text")
	local amount_text = objectives_panel:child("amount_text")
	local bar_left = self._bg_box:child("bar_left")
	local bar_right = self._bg_box:child("bar_right")
	local bar_mid = self._bg_box:child("bar_mid")
	bar_left:set_color(Restoration.objective_color)
	bar_right:set_color(Restoration.objective_color)
	bar_mid:set_color(Restoration.objective_color)
	amount_text:set_color(Restoration.objective_textcolor)
	objective_text:set_color(Restoration.objective_textcolor)
end
function HUDObjectives:_animate_icon_objectivebox( icon_objectivebox )
	local TOTAL_T = 5
	local t = TOTAL_T
	local color = Restoration.objective_color
	icon_objectivebox:set_x( 0 )
	while t > 0 do
		local dt = coroutine.yield()
		t = t - dt
		
		local curval = (TOTAL_T-t)
		local smt = math.round((1 + math.sin( curval * 450 * 2 )) * (12 * (t/TOTAL_T) ))
		
		local blink = 1 - (1 + math.sin( curval * math.pi * 200 ) )/2
		
		local col = Color( (1 - (1 - color.r) * blink), (1 - (1 - color.g) * blink), (1 - (1 - color.b) * blink) )
		
		if icon_objectivebox:child( "bar_left" ) then	
			icon_objectivebox:child( "bar_left" ):set_color( col )
		end
		if icon_objectivebox:child( "bar_mid" ) then
			icon_objectivebox:child( "bar_mid" ):set_color( col )
		end
		if icon_objectivebox:child( "bar_right" ) then
			icon_objectivebox:child( "bar_right" ):set_color( col )
		end
		
		icon_objectivebox:set_x( 0 + smt )
		if self._hud_panel and self._hud_panel:child( "objectives_panel" ) then
			local objectives_panel = self._hud_panel:child( "objectives_panel" )
			local objective_text = objectives_panel:child( "objective_text" )
			objective_text:set_x( 8 + smt )
			local amount_text = objectives_panel:child( "amount_text" )
			local _,_,w,_ = objective_text:text_rect()
			amount_text:set_x( objective_text:x() + 4 + w )
		end
		
	end
	icon_objectivebox:set_x( 0 )
		
	if icon_objectivebox:child( "bar_left" ) then	
		icon_objectivebox:child( "bar_left" ):set_color( color )
	end
	if icon_objectivebox:child( "bar_mid" ) then
		icon_objectivebox:child( "bar_mid" ):set_color( color )
	end
	if icon_objectivebox:child( "bar_right" ) then
		icon_objectivebox:child( "bar_right" ):set_color( color )
	end
		
	if self._hud_panel and self._hud_panel:child( "objectives_panel" ) then
		local objectives_panel = self._hud_panel:child( "objectives_panel" )
		local objective_text = objectives_panel:child( "objective_text" )
		objective_text:set_x( 8 )
		local amount_text = objectives_panel:child( "amount_text" )
		local _,_,w,_ = objective_text:text_rect()
		amount_text:set_x( objective_text:x() + 4 + w )
	end
	
end
